<?php // $Id$


/**
 * implementation of theme_menu_local_tasks
 */
function theme_tiptasks() {
  //print_r(tiptasks_local_tasks());
  $tasks = '<div class="tasks-wrapper" >'.tiptasks_local_tasks().'</div>';
  return $tasks;
}


/**
 * override tasks in page template. needed because theme hook functions cannot
 * be overriden by module prefix which is bad for menu_local_tasks, because
 * it is common to create a phptemplate override in a theme's template.php like garland does. 
 * This essentially means, we cannot use phptemplate_menu_local_tasks, or redeclare-errors may happen.
 * 
 * Many themes also cut the tabs and reassign them on preprocess_page, so we need
 * to store our menu in a different field:
 */
function tiptasks_preprocess_page(&$vars){
	// only if tabs are filled (means, there is something)
	if($vars['tabs']){
		$vars['tasks'] = theme('tiptasks');
	}
}


/**
 * render a nested task
 */
function tiptasks_local_task(&$tasks, $item, $parent = NULL){
  if(!$item['data']['access']) return;
  $link = theme('menu_item_link', $item['data']);
  
  $menu = '';
  if(isset($item['children'])){
    foreach($item['children'] as $child) $menu .= tiptasks_local_task($tasks, $child, $item);
  }
  
  if($menu){
  	$menu = '<ul class="tasks secondary">'.$menu.'</ul>';
    $output = theme_menu_item($link , TRUE, $menu, isset($item['active']));
  } else{
  	$output = theme_menu_item($link , FALSE);
  }
  
  return $output;
}

/**
 * get a nested tree of local tasks ... 
 */
function tiptasks_local_tasks() {
  static $output;
  static $tree;
  
  if(!isset($tree)){
  	
  	$router_item = menu_get_item();
    if (!$router_item || !$router_item['access']) {
      return '';
    }
    // Get all tabs and the root page.
    $result = db_query("SELECT * FROM {menu_router} WHERE tab_root = '%s' ORDER BY weight, title", $router_item['tab_root']);
    $map = arg();
    $tasks = array();
    $path = $router_item['path'];
    
    // build tabs tree
    while ($item = db_fetch_array($result)) {
      _menu_translate($item, $map, TRUE);
      $tasks[$item['path']] = $item;
      
      if ($item['tab_parent']) {
      	if($item['tab_parent'] != $item['tab_root']){
      		$tree[$item['tab_parent']]['children'][$item['path']]['data'] = $item;
      	} else {
        	$tree[$item['path']]['data'] = isset($tree[$item['path']]['data']) 
      			? array_merge($item,$tree[$item['path']]['data']) : $item;
      	}
      	// create active links
      	if($item['path'] == $path){
      	  $item['localized_options'] = array('attributes' => array('class' =>'active'));
      	  if($item['tab_parent'] != $item['tab_root']) 
      	    $tree[$item['tab_parent']]['data']['localized_options']  = $item['localized_options'];
      	}
      }
      
    }
    $output .= '<ul class="tasks primary">';
 	foreach($tree as $item) $output .= tiptasks_local_task($tasks, $item);
    $output .= '</ul>';
  }
  return $output;
  
}
